require_relative 'fundrequest'
require_relative 'die'
require_relative 'pledge_pool'
require_relative 'fundable'

module CrowdFund
  class Project
    include Fundable

    attr_accessor :name, :funding
    attr_reader :funding, :target

    def initialize(name, target_amount, funding=0)
      @name = name
      @target = target_amount
      @funding = funding
      @found_pledge = Hash.new(0)
    end

    def self.from_csv(string)
      name, funding, target = string.split(',')
      Project.new(name, Integer(funding), Integer(target))
    end

    def pledges
      @found_pledge.values.reduce(0, :+)
    end

    def each_pledge
      @found_pledge.each do |name, amount|
        pledge = Pledge.new(name, amount)
        yield pledge
      end
    end

    def found_pledge(pledge)
      @found_pledge[pledge.name] += pledge.amount

      puts "#{@name} received a #{pledge.name} pledge worth #{pledge.amount}."
      puts "#{@name}'s pledges: #{@found_pledge} "
    end

    def to_s
      "I'm #{@name}'s with a pledge = #{@found_pledge}. "
    end
  end
end 

  if __FILE__ == $0
    project = Project.new("Project ABC", 5000, 1000)
    puts project.name
    puts project.funding
    project.remove_funds
    puts project.funding
    project.add_funds
    puts project.funding
  end
